#!/bin/python
#-*- coding: utf-8 -*-
import os
import subprocess
from lib_result import *

def get_cpu_nums():
    try:
        num = 0
        cpuinfos = subprocess.check_output( ['lscpu']).split('\n')
        for cpuinfo in cpuinfos:
            if (cpuinfo.startswith('CPU(s):') or cpuinfo.startswith('CPU:')) and cpuinfo.split()[1].isdigit():
                num = int(cpuinfo.split()[1])
                break
        return Result( None, num)
    except Exception as e:
        return Result( 'Error:' + str(e), None)

def get_mem_capacity():
    try:
        mem = 0
        mem_infos = subprocess.check_output( ['dmidecode', '-t', 'memory']).split('\n')
        for mem_info in mem_infos:
            if mem_info.startswith("\tSize") and mem_info.endswith("MB") and mem_info.split()[1].isdigit():
                mem += int(mem_info.split()[1])
                continue
        return Result( None, mem)
    except Exception as e:
        return Result( 'Error:' + str(e), None)

def get_system_boot_state():
    if not os.path.isdir("/sys/firmware/efi/"):
        return "Legacy"
    else:
        return "EFI"

# debug
# print get_cpu_nums().getValue()
# print get_mem_capacity().getValue()

